' Directory-Makro
' (c) 1997 Bodo Meseke
' http://starpage.home.pages.de
' meseke@tap.de
'
' Dieses Mako fgt an der Cursor-
' position das Inhaltsverzeich-
' nis eines anzugebenden Laufwerks
' oder Unterverzeichnisses ein.
'
' Da StarBasic keine Rekursion 
' beherrscht, mu der Pfad immer
' mittels der Funktionen UPVERZ$
' und LETZTES$ analysiert werden 
' um ein korrektes Durchsuchen
' des Verzeichnisbaumes zu ermg-
' lichen.
'
' Das Startverzeichnis sollte
' korrekt eingegeben werden, 
' lediglich ein vergessener
' Backslash am Ende wird durch
' das Makro ergnzt. Mehr wrde
' das in Ermangelung rekursiver
' Funktionen ohnehin recht lange
' Makro nur noch weiter auf-
' bauschen.
'
' Beim Gegentest mit dem Norton
' Commander fr Win95 liefert
' dieser brigens ein Verzeich-
' nis mehr, da er das Laufwerk
' selber auch als Verzeichnis
' zhlt.
'
' ffentliche Variablen festlegen
Public Pfad$, LastVerz$, Datei$
Public VerzTiefe%, Verz%
Public Platz as Boolean
'
Sub Laufwerklesen
'
' Fehlerbehandlungsroutine
On Error GoTo Fehlerbehandlung
' Abfrage ob StarWriter das aktive Modul ist
If ActiveModule.Name<>"StarWriter" then 
  Print "Makro luft nur in StarWriter !"
  Stop
EndIf
'
' Variablen initialisieren,
' Normal% = "Normal"-Bit 
' Hidden% = Versteckt-Bit
' System% = System-Bit
' Verz%   = Verzeichnis-Bit
' Auswahl%= Bitmuster, hier
' werden alle Dateien und
' Verzeichnisse gesucht.
' 
' Volume% ist das Bitmuster fr
' den Laufwerksnamen.
Normal%=0
Hidden%=2
System%=4
Verz%=16
Auswahl%=Normal%+Hidden%+System%+Verz%
Volume%=8
'
' Verzeichnistiefe, Anzahl der Dateien,
' Anzahl der Unterverzeichnisse.
VerzTiefe%=0
DatZahl%=0
VerzZahl%=0
'
' Vor Dateinamen Platzhalter statt
' des Pfades einfgen ?
Platz=True
'
' Startverzeichnisse eingeben lassen:
Pfad$=InputBox$ ("Startverzeichnis eingeben"+chr$(13)+"(Am Ende '\')","Start")
'
' Kein Pfad ? Dann Abbruch.
if Pfad$="" then exit sub
'
' Ggf. den Backslash ergnzen
if right$(Pfad$,1)<>"\" then Pfad$=Pfad$+"\"
'
' Statusmeldung anzeigen
Application.StatusBar="Makro luft "
' Bildschirmaktivitt stoppen 
Selection.ActionStart()
'
' Laufwerksbezeichnung einlesen
Laufwerk$=dir$(Pfad$,8)
Selection.Insert "Inhaltsverzeichnis von "+Pfad$+" ["+Laufwerk$+"]"
Selection.InsertPara
Selection.InsertPara
'
' Ersten Datei-/Verzeichnisnamen holen.
Datei$=dir$(Pfad$,Auswahl%)
'
' Ist das Laufwerk leer ?
if Datei$<>"" then do
	'
	' Laufwerk ist nicht leer, also erstmal den gefundenen 
	' Verzeichniseintrag anzeigen.
	if Gueltig then
		if VerzeichnisGefunden then
			VerzZahl%=VerzZahl%+1
			Application.StatusBar=Application.StatusBar+"."
		else
			DatZahl%=DatZahl%+1
		end if
		' Datei-/Verzeichnisnamen ausgeben.
		if VerzeichnisGefunden then
			if Platz then
				Platzhalter(VerzTiefe)
			end if
			' Verzeichnispfade immer komplett.
			selection.insert Pfad$
		else
			' Bei Dateien ggf. Platzhalter
			' statt des kompletten Pfades
			if Platz then
				Platzhalter(VerzTiefe)
			else
				selection.insert Pfad$
			end if
		end if
			selection.insert Datei$
			selection.insertpara
	endif
	'	
	' Verzeichnis gefunden, aber nicht "." oder ".." ?
	if (Gueltig and VerzeichnisGefunden) then
		'		
		' Ja, es ist ein Verzeichnis
		' In neues Verzeichnis wechseln, 
		' Tiefe merken, 
		' Suche neu initialisieren.
		Pfad$=Pfad$+Datei$+"\"
		VerzTiefe%=VerzTiefe%+1
		Datei$=Dir$(Pfad,Auswahl%)
	'	
	' Kein Verzeichnis, aber vielleicht Verzeichnisende erreicht 
	' und noch nicht auf der obersten Verzeichnisebene ?
	elseif (Datei$="" ) and (VerzTiefe%>0) then
		'
		' Ja, also in die nchsthhere Verzeichnisebene wechseln
		' Letztes Verzeichnis vorher merken
		LastVerz$=Letztes$(Pfad$)
		Pfad$=UpVerz$(Pfad$)
		VerzTiefe%=VerzTiefe%-1
		'
		' Neuen Pfad initialisieren.
		Datei$=Dir$(Pfad$,Auswahl%)
		'
		' Eintrag gefunden ?
		' Wenn ja, dann solange weiterlesen, bis ein neuer
		' Eintrag auftaucht, also nicht wieder in das letzte 
		' Verzeichnis springen.
		if Datei$<>"" and Datei$<>LastVerz$ then do
			Datei$=Dir$
		loop until Datei$=LastVerz$
		Datei$=Dir$
	else
		Datei$=Dir$
	end if
	'
' Solange, bis keine Datei mehr
' da ist und auch kein ber-
' geordnetes Verzeichnis.
loop until (Datei$="") and (VerzTiefe%=0)
'
' Gesamtzahl der Dateien und 
' Verzeichnisse ausgeben.
selection.insertpara
selection.insert "Gesamtzahl Verzeichnisse	: "+str$(VerzZahl%)
selection.insertpara
selection.insert "Gesamtzahl Dateien		: "+str$(DatZahl%)
selection.insertpara
'
'Bildschirmaktivitt wieder einschalten
Selection.ActionEnd()
Application.StatusBar="Makro erfolgreich beendet."
exit sub
'
'
Fehlerbehandlung:
' Hier werden Fehler abgefangen,
' da Programm jedoch beendet. Es
' erfolgt aber kein Wechsel in 
' den StarBasic-Editor.
'
	'Bildschirmaktivitt zuerst einschalten
	Selection.ActionEnd()
	Application.StatusBar="Whrend der Ausfhrung ist ein Fehler aufgetreten!"
	Fehler% = Err
	Beep
	Meldung$ = "Fehlernummer:" + Str$(Fehler%)
	Meldung$ = Meldung$ + Chr$(13)
	Meldung$ = Meldung$ + "Fehlerbezeichnung: "
	Meldung$ = Meldung$ + Error$(Fehler%)
	Meldung$ = Meldung$ + Chr$(13)
	Meldung$ = Meldung$ + "Makro wird beendet !"
	MsgBox Meldung$
'
end sub
'
'
function UpVerz$ (v1$)
' Die Funktion liefert aus
' dem kompletten Pfad das
' bergeordnete Verzeichnis
' zurck.
dim i1, z1$
i1=len(v1$)-1
do
	z1$=mid$(v1$,i1,1)
	i1=i1-1
loop until z1$="\"
UpVerz$=left$(v1$,i1+1)
end function
'
'
function Letztes$ (v2$)
' Die Funktion liefert aus
' dem kompletten Pfad das
' zuletzt durchsuchte Ver-
' zeichnis zurck.
'
dim i2, z2$
i2=len(v2$)-1
do
	z2$=mid$(v2$,i2,1)
	i2=i2-1
loop until z2$="\"
Letztes$=mid$(v2$,i2+2,len(v2$)-2-i2)
end function
'
'
function Gueltig as boolean
' Gueltig ist "TRUE", wenn ein
' gltiger Dateiname gefunden
' wurde.
'
	Gueltig=((Datei$<>"") and (Datei$<>".") and (Datei$<>".."))
'	
end function
'
'
function VerzeichnisGefunden as boolean
' VerzeichnisGefunden ist 
' "TRUE", wenn es sich bei dem
' gefundenen Eintrag um ein
' Verzeichnis handelt.
'
	VerzeichnisGefunden=((getattr(Pfad$+Datei$) and verz%)=verz%)
'	
end function
'
'
sub Platzhalter (Anzahl%)
' Fgt ANZAHL% Platzhalter ein
'
i2=0
if Anzahl%<>0 then 
	do
		' Fr den "." einfach 
		' einen Platzhalter
		' eigener Wahl ein-
		' setzen !
		selection.insert "."
		i2=i2+1
	loop until i2=Anzahl%
end if
'
end sub
'
'History
'
'15.09.1997
'Abfrage nach aktivem Modul eingefgt
'ActionStart() und ActionEnd() eingefgt
'Statusanzeige eingefgt, jedes Verzeichnis ein neuer Punkt
